VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BotnetPacket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public BNServer As String
Public BNPort As Long
Public BNServerPwd As String
Public BNDatabase As String
Public BNDatabasePwd As String
Public Connected As Boolean
Public Dirty As Boolean

Private Bytes(511) As Byte
Private PacketLen As Integer

'give up packet contents
Public Property Get GetPacket(ByRef bytesPacket() As Byte) As Long
    
    Dim lCnt As Long
    
    ReDim bytesPacket(PacketLen - 1)
    For lCnt = 0 To PacketLen - 1
        bytesPacket(lCnt) = Bytes(lCnt)
    Next lCnt
    
    'return whole packet length
    GetPacket = PacketLen
    
    'create new packet
    Bytes(0) = PROTOCOL_VERSION
    Bytes(1) = &H0
    PacketLen = 4
    
    'update packet length field
    Bytes(2) = PacketLen And &HFF
    Bytes(3) = PacketLen / 256
    
End Property

Public Property Get PacketID() As Byte
    PacketID = Bytes(1)
End Property

Public Property Let PacketID(ByVal bPacketID As Byte)
    Bytes(1) = bPacketID
End Property

Public Function InsertByte(ByVal byteData As Byte) As Long
    
    Bytes(PacketLen) = byteData
    PacketLen = PacketLen + 1
    
    'update packet length field
    Bytes(2) = PacketLen And &HFF
    Bytes(3) = PacketLen / 256
    
    'return whole packet length
    Dirty = True
    InsertByte = PacketLen
    
End Function

Public Function InsertWord(ByVal wordData As Integer) As Long
    
    Bytes(PacketLen) = wordData And &HFF
    Bytes(PacketLen + 1) = wordData / 256
    PacketLen = PacketLen + 2
    
    'update packet length field
    Bytes(2) = PacketLen And &HFF
    Bytes(3) = PacketLen / 256
    
    'return whole packet length
    Dirty = True
    InsertWord = PacketLen
    
End Function

Public Function InsertDWord(ByVal dwordData As Long) As Long
    
    Dim tmpL As Long
    
    Bytes(PacketLen) = dwordData And &HFF
    
    tmpL = dwordData / 256
    Bytes(PacketLen + 1) = tmpL And &HFF
    
    tmpL = dwordData / 256
    tmpL = tmpL / 256
    Bytes(PacketLen + 2) = tmpL And &HFF
    
    tmpL = dwordData / 256
    tmpL = tmpL / 256
    tmpL = tmpL / 256
    Bytes(PacketLen + 3) = tmpL And &HFF
    
    PacketLen = PacketLen + 4
    
    'update packet length field
    Bytes(2) = PacketLen And &HFF
    Bytes(3) = PacketLen / 256
    
    'return whole packet length
    Dirty = True
    InsertDWord = PacketLen
    
End Function

Public Function InsertString(ByVal stringData As String) As Long
    
    Dim lCnt As Long
    
    For lCnt = 1 To Len(stringData)
        Bytes(PacketLen + lCnt - 1) = Asc(Mid(stringData, lCnt, 1))
    Next lCnt
    PacketLen = PacketLen + Len(stringData)
    
    'add null terminator
    Bytes(PacketLen) = &H0
    PacketLen = PacketLen + 1
    
    'update packet length field
    Bytes(2) = PacketLen And &HFF
    Bytes(3) = PacketLen / 256
    
    'return whole packet length
    Dirty = True
    InsertString = PacketLen
    
End Function

Private Sub Class_Initialize()
    
    Connected = False
    
    'create new packet
    Bytes(0) = PROTOCOL_VERSION
    Bytes(1) = &H0
    PacketLen = 4
    
    'update packet length field
    Bytes(2) = PacketLen And &HFF
    Bytes(3) = PacketLen / 256
    
    Dirty = False
    
End Sub
